//
// Created by koerberm on 11.04.18.
//

#include "ep_common.h"
#include "event.h"

namespace ep {

    ep_exception::ep_exception(const std::string &message) : msg(message) {
    }

    std::ostream &operator<<(std::ostream &s, const ep_exception &ex) {
        return s << ex.msg;
    }

    const char *ep_exception::what() const noexcept {
        return msg.c_str();
    }

    ep_exception::ep_exception(const ep_exception &e) noexcept : msg(e.msg) {
    }


    uint32_t next_multiple_of_two(uint32_t v)  {
        uint32_t r = 1;
        while ( r < v )
            r = r << 1;
        return r;
    }

    std::ostream& operator<<(std::ostream &o, const event& p) {
        o << "(" << p.timestamp;
        for ( uint i = 0; i < NUM_VALUES; i++ ) {
            o << ", " << p.values[i];
        }
        return o << ")";
    }

    std::ostream& operator<<(std::ostream &o, const joined_event& p) {
        o << "(" << p.timestamp;
        for ( uint i = 0; i < 2*NUM_VALUES; i++ ) {
            o << ", " << p.values[i];
        }
        return o << ")";
    }

}