//
// Created by koerberm on 11.04.18.
//

#ifndef EPHSA_EP_COMMON_H
#define EPHSA_EP_COMMON_H

#include <exception>
#include <string>
#include <cstdio>

#define DEBUG false
#define debug_print(fmt, ...) \
            do { if (DEBUG) fprintf(stderr, fmt, __VA_ARGS__); } while (false)




namespace ep {

    class ep_exception : public std::exception {
    public:
        explicit ep_exception(const std::string &message);

        ep_exception(const ep_exception &ex) noexcept;

        friend std::ostream &operator<<(std::ostream &s, const ep_exception &ex);

        ~ep_exception() override = default;

        const char *what() const noexcept override;

    private:
        std::string msg;
    };

    uint32_t next_multiple_of_two(uint32_t v);
}

#endif //EPHSA_EP_COMMON_H
