#include "../../shared.h"
#include "../../cl_common.h"

__kernel void hells_aggregate_init(
        __global   T *in,
        __global   AGG_TYPE *out,
                   ulong element_count,
                   uint  elements_per_item)
{

    const size_t global_size = get_global_linear_size();
    const size_t id          = get_global_linear_id();
    ulong        i           = id;

    AGG_TYPE accum = agg_init(&in[i]);

    for ( i = i + global_size; i < element_count; i+= global_size ) {
        agg_merge(&accum, agg_init(&in[i]));
    }
    out[id] = accum;
}

__kernel void hells_aggregate(
        __global   AGG_TYPE *in,
        __global   AGG_TYPE *out,
                   ulong element_count,
                   uint  elements_per_item)
{
    const size_t global_size = get_global_linear_size();
    const size_t id          = get_global_linear_id();
    ulong        i           = id;

    AGG_TYPE accum = in[i];

    for ( i = i + global_size; i < element_count; i+= global_size ) {
        agg_merge(&accum, in[i]);
    }
    out[id] = accum;
}