// Note, event type T defined externally

#include "../../shared.h"

__kernel void hells_filter(
        __global queue_def *in_q,
                 long       in_start,
                 uint       batch_size,
        __global HELLS_FILTER_BITFIELD_TYPE      *results)
{
    const size_t               global_id = get_global_linear_id();
    HELLS_FILTER_BITFIELD_TYPE res       = 0;

    const T     *base = in_q->base;
    const ulong  mask = in_q->mask;

    const uint   elems_per_thread = sizeof(HELLS_FILTER_BITFIELD_TYPE) << 3;

    for ( uint bit = 0 ; bit < elems_per_thread; bit++ ) {
        const long  idx   = global_id * elems_per_thread + bit;
        const ulong p_idx = ((ulong) in_start + idx) & mask;
        if ( idx < batch_size && filter_predicate(&base[p_idx]) ) {
            res |= (1 << bit);
        }
    }
    results[global_id] = res;
}