//
// Created by koerberm on 06.03.19.
//

#ifndef EPHSA_CL_COMMON_H
#define EPHSA_CL_COMMON_H

inline size_t get_local_linear_size() {
    size_t wg_size = get_local_size(0);
    for (uint i = 1; i < get_work_dim(); i++ )
        wg_size *= get_local_size(i);
    return wg_size;
}

inline size_t get_global_linear_size() {
    size_t result = get_global_size(0);
    for (uint i = 1; i < get_work_dim(); i++ )
        result *= get_global_size(i);
    return result;
}

inline size_t get_linear_num_groups() {
    size_t result = get_num_groups(0);
    for (uint i = 1; i < get_work_dim(); i++ )
        result *= get_num_groups(i);
    return result;
}

inline size_t get_linear_group_id () {
    size_t result = get_group_id (0);
    for (uint i = 1; i < get_work_dim(); i++ ) {
        result += (get_group_id(i)*get_num_groups(i-1));
    }
    return result;
}

#endif //EPHSA_HSA_COMMON_H
