//
// Created by koerberm on 06.03.19.
//

#ifndef EPHSA_XLANE_H
#define EPHSA_XLANE_H

#include "/opt/rocm/include/ockl_hsa.h"
#define ICMP_NE 33

/**
 * @return The id of the current lane
 */
uint lane_id() {
    return __ockl_lane_u32();
}

/**
 * @return The id of the current lane (only respecting currently active lanes)
 */
uint active_lane_id() {
    return  __ockl_activelane_u32();
}

/**
 * @return The number of currently active lanes
 */
uint active_lane_count() {
    return __builtin_popcountl(__builtin_amdgcn_read_exec());
}

/**
 * @return The number of lanes where v == true
 */
uint lane_count(const bool v) {
    return __builtin_popcountl(__builtin_amdgcn_sicmp(v, 0, ICMP_NE));
}

ulong broadcast_u64(const ulong value, const uint lane) {
    uint j = __builtin_amdgcn_readfirstlane(lane);
    ulong v1 = (ulong)__builtin_amdgcn_readlane((uint)(value >> 32), j) << 32;
    uint  v2 = __builtin_amdgcn_readlane((uint)value, j);
    return v1 | v2;
}

ulong broadcast_u32(const uint value, const uint lane) {
    uint j = __builtin_amdgcn_readfirstlane(lane);
    return __builtin_amdgcn_readlane(value, j);
}

#endif //EPHSA_XLANE_H
